import java.util.Random;

/**
 * Write a description of class Test here.
 * 
 * @author Martin ehnek
 * @version 9.10.2006
 */
public class Main
{
	public static final int MAX_ITERACI = 10000;
	
	public static void main(String[] args)
	
	{   int celkemH1 = 0;
	    int celkemH2 = 0;
	    
	    int[][][] mojepole = new int[5][][];
	    for (int i = 0; i<5; i++)
	      {mojepole[i] = randomPole();
	       System.out.println(i + ".Testovani heuristiky manhattanske vzdalenosti:");
	       celkemH1 += run(1,mojepole[i],false);
	       celkemH1 += run(2,mojepole[i],false);
	       System.out.println("Konec\n");
	      }
	      
	      System.out.println("Prumerna ucinnost H1 = " + (double)celkemH1/5);
	      System.out.println("Prumerna ucinnost H2 = " + (double)celkemH2/5);
	      System.out.println("# - pocet kroku, ## - skutecna vzdalenost od korene");
	
	}
	 
	/**
	 * @param which Which heuristic will be used (only 1 or 2)
	 */ 
	public static int run( int which, int[][] initPole, boolean vypis) 
	{
	    Uzel current = new Uzel(initPole,null);
	    System.out.println(current);
        Uzel newCurrent;
	    int nejlepsi = 9;
	    int i = 0; int j = 0;
	    int citac = 0;
	    
	    while (citac < MAX_ITERACI && !current.isFinal()) 
	     {
	         if (vypis) System.out.println("#" + citac  + "  ##" + current.getVzdalenost()  + "\n" + current); 
	         current.setH(which);
	         if (!current.getSonsCreated())
	           current.setPotomci(which);
	         
	         if ((newCurrent=current.vyberNejPotomka(which))!= null) //ma smysluplneho syna, co se neopakoval
	            current = newCurrent;
	         else //zadny syn uz neni vhodny 
	           {   
	               for(i=0;i<4;i++)  //smazat currenta z pole jeho otce
	                 if ( (current.getOtec() != null) && (current.getOtec().potomci[i] == current) )
	                   {
	                       current.getOtec().potomci[i] = null;
	                       break;
	                   }
	               current = current.getOtec();
	           }
	         citac ++;
           }
	     
	    if (citac == MAX_ITERACI)
	      System.out.println("Ani v " + MAX_ITERACI + " krocich se nepodarilo nalezt vysledek.");
	    else  
	     System.out.println("Spravne usporadal, trvalo to " + citac + " kroku.");
	     System.out.println("Skutecna vzdalenost od korene: " + current.getVzdalenost() + "\n");
	    return citac;
	   
	   }

     public static int[] intToCoordinate(int i)
     {   int[] navrat = new int[2];
         switch(i)
            { case 0: navrat[0] = 1;
                      navrat[1] = 1;
                      break;
              case 1: navrat[0] = 0;
                      navrat[1] = 0;
                      break;
              case 2: navrat[0] = 1;
                      navrat[1] = 0;
                      break;
              case 3: navrat[0] = 2;
                      navrat[1] = 0;
                      break;
              case 4: navrat[0] = 2;
                      navrat[1] = 1;
                      break;
              case 5: navrat[0] = 2;
                      navrat[1] = 2;
                      break;
              case 6: navrat[0] = 1;
                      navrat[1] = 2;
                      break;
              case 7: navrat[0] = 0;
                      navrat[1] = 2;
                      break;
              case 8: navrat[0] = 0;
                      navrat[1] = 1;
                      break;
           }
        return navrat;
    }  

    public static int[][] randomPole()
    {   int navrat[][] = new int[3][3];
        int[] souradnice;
        int i = 0;
        boolean[] used = new boolean[9];
	     for(i =0; i<8; i++)
	       used[i]=false;
        int pozice = 0;
	    Random mujRandom = new Random();
	    for(i = 0; i<9; i++)  //pro vsech 8 ctverecku
	      { 
	          while(used[pozice = mujRandom.nextInt(9)]) {} //pozice uz byla vytahnuta 
	          used[pozice] = true;
	          souradnice = intToCoordinate(pozice);
	          navrat[souradnice[0]][souradnice[1]] = i;
	      }  
	   return navrat;   
	}
    

	public static void test()
    {
     int[][] pole = randomPole();
     Uzel uzel = new Uzel(pole, null);
     System.out.println(uzel);
     
    }
}


