import java.util.Random;

/**
 * Write a description of class Uzel here.
 * 
 * @author Martin ehnek
 * @version 9.10.2006
 */
public class Uzel
{
	
	private static final int[][] spravnePole = {{1,8,7},{2,0,6},{3,4,5}};
    private int h1; //vaha heuristiky chybneho umisteni
    private int h2; //vaha heuristiky manhattanske vzdalenosti
	private int[][] ctverce;
	public int mezX; 
	public int mezY;
	private Uzel otec;
	public Uzel[] potomci = new Uzel[4];
	private boolean sonsCreated = false;
	private int vzdalenost = 0; //vzdalenost od korene (pocet primych kroku)
	
	public Uzel getOtec()
	  {return otec;}
	
	public boolean getSonsCreated()
	  {return sonsCreated;}
	  
	public int getVzdalenost()
	  {return vzdalenost;}
	
	/**
	 * Constructor for objects of class Uzel
	 * @param ctverce Reference to an array of array (3*3). !Array must be actually created somewhere!
	 */
	public Uzel(int[][] ctverce, Uzel otec) //predpoklada se platne pole{3*3}, kde se napr. neopakuji a nechybi cisla
	{   this.otec = otec;
	    if (this.otec != null)
	     vzdalenost = otec.vzdalenost + 1 ;
	    h1=h2=0;
	    this.ctverce = ctverce;
	    for (int i = 0; i<3; i++) //prohledat, najit 0 a priradit souradnice mezX a mezY mezery
	     for (int j = 0; j<3; j++)
	       if (ctverce[j][i] == 0)
	        {
	           mezX = j;
	           mezY = i;
	       }
	}

    /**
	 * Constructor for objects of class Uzel
	 * @param ctverce Reference to an array of array (3*3). !Array must be actually created somewhere!
	 * @param mezX X coordinate of the "space"
	 * @param mezX Y coordinate of the "space"
	 */
	public Uzel(int[][] ctverce, int mezX, int mezY, Uzel otec) //predpoklada se platne pole{3*3}, kde se napr neopakuji a nechybi cisla
	{   
	    this.otec = otec;
	    if (otec != null)
	     vzdalenost = otec.vzdalenost + 1 ;
	    h1=h2=0;
	    this.ctverce = ctverce;
	    this.mezX = mezX;
	    this.mezY = mezY;
	    
	}

	/**
	 * String representing setting of the board
	 * @return Grid with setting of the board
	 */
	public String toString()
	{
	    String navrat = "";
	    for (int i = 0; i<3; i++)
	     {for (int j = 0; j<3; j++)
	        {
	           navrat += (ctverce[j][i] == 0) ? " " : ctverce[j][i];
	           if (j!=2)
	             navrat += "|";
	           else 
	             navrat += "\n";
	       }
	     }     
	       
	    return navrat;
	}
	   
	/**
	 * Returns new son that originates from father by moving the space in specified direction 
	 * 
	 * @param smer Direction in which is the new son created.
	 * @return New created son.
	 */
	public Uzel syn(Direction smer)  //takovy syn, ze se mezera posune v danem smeru
	{
	    int newX = 0;
	    int newY = 0;
	    int temp;
	    switch(smer)
	      {case UP: newX = mezX;
	                newY = mezY - 1;
	                break;
	       case DOWN: newX = mezX;
	                  newY = mezY + 1;
	                  break;
	       case RIGHT: newX = mezX + 1;
	                   newY = mezY;
	                   break;
	       case LEFT: newX = mezX - 1;
	                  newY = mezY;
	                  break;
	      }
	   int[][] synovoPole = new int[3][3]; 
	   for(int i = 0; i<3; i++) //prekopirovat pole synovi
	      System.arraycopy(ctverce[i],0,synovoPole[i],0,ctverce[i].length);
	   //vymena mezery
	   synovoPole[mezX][mezY] = synovoPole[newX][newY];
	   synovoPole[newX][newY] = 0;
	   return new Uzel(synovoPole, newX, newY,this);
	}
	   
	
	/**
	 * Runs the first heuristik and sets variable h1
	 */
	public void setH1()
	{
	    int rozdilu = 0;  //kdyztak rovnou h1++
	    for (int i = 0; i<3; i++)
	     for (int j = 0; j<3; j++)
	      if ( (ctverce[j][i] != 0) && (ctverce[j][i] != spravnePole[j][i]) ) 
	        rozdilu++;
	    h1 = rozdilu;
	}
	
	/**
	 * Runs the second heuristik and sets variable h2
	 */
	public void setH2()
	{
	    for (int i = 0; i<3; i++)
	      for (int j = 0; j<3; j++)
	       {
	           switch (ctverce[j][i])
	            {
	                case 1: h2 += Math.abs(j - 0) + Math.abs(i - 0);
	                        break;
	                case 2: h2 += Math.abs(j - 1) + Math.abs(i - 0);
	                        break;
	                case 3: h2 += Math.abs(j - 2) + Math.abs(i - 0);
	                        break;
	                case 4: h2 += Math.abs(j - 2) + Math.abs(i - 1);
	                        break;
	                case 5: h2 += Math.abs(j - 2) + Math.abs(i - 2);
	                        break;
	                case 6: h2 += Math.abs(j - 1) + Math.abs(i - 2);
	                        break;
	                case 7: h2 += Math.abs(j - 0) + Math.abs(i - 2);
	                        break;
	                case 8: h2 += Math.abs(j - 0) + Math.abs(i - 1);
	                        break;
	            }   
	           
	       }
	}
	
	public int getH1()
	   {return h1;}
	
	public int getH2()
	  {return h2;}
	
	/**
	 * Returns true if the ctverce[][] of the are the same as spravnePole[][] (Not same objects but same values) 
	 * @return true if the ctverce[][] of the are the same as spravnePole[][]
	 */
	public boolean isEqual(int[][] pole)
	{
	    for (int i = 0; i<3; i++)
	     for (int j = 0; j<3; j++)
	      if ( ctverce[j][i] != pole[j][i])
	        return false;
	    return true;
	}
	
	/**
	 * Returns true if the ctverce[][] of the are the same as spravnePole[][] (Not same objects but same values) 
	 * @return true if the ctverce[][] of the are the same as spravnePole[][]
	 */
	public boolean isFinal()
	{
	    return isEqual(spravnePole);
	}
	
	/**
	 * Returns value of h1 or h2
	 * @param i The number of heuristic
	 * @return Value of h1 or h2 according to the paramether
	 */
	public int getH(int i)
	{
	    if (i == 1)
	      return getH1();
	    else if (i == 2)
	      return getH2();
	    else 
	      return 0;
	}
	
	/**
	 * Calls one of two heuristics
	 * @param i Which heuristic will be chosen
	 */
	public void setH(int i)
	{
	    if (i == 1)
	      setH1();
	    else if (i == 2)
	      setH2();
	}
	    
	
	/**
	 * Returns whether is it possible to go in specified direction
	 * @param smer Direction in which we want to know if is it possible to go
	 * @return True if it is possible to go in specified direction
	 */
	public boolean isPossible(Direction smer)
	{   boolean possible = true;
	    switch(smer)
	      {
	       case UP:    if (mezY == 0) 
	                     {possible = false; }
	                   break;  
	       case DOWN:  if (mezY == 2) 
	                     {possible = false; }
	                   break;  
	       case RIGHT: if (mezX == 2) 
	                     {possible = false; }
	                   break;  
	       case LEFT:  if (mezX == 0) 
	                     {possible = false; }
	                   break;  
	      }
	    return possible;
	}    
	
	public void setPotomci(int which)
	{   sonsCreated = true;
	    if (isPossible(Direction.UP))  
	           {
	               potomci[0] = syn(Direction.UP);
	               potomci[0].setH(which);
	            }
	         if (isPossible(Direction.DOWN))
	           {
	               potomci[1] = syn(Direction.DOWN);
	               potomci[1].setH(which);
	           }
	         if (isPossible(Direction.RIGHT))
	           {
	               potomci[2] = syn(Direction.RIGHT);
	               potomci[2].setH(which);
	           }
	         if (isPossible(Direction.LEFT))
	           {
	               potomci[3] = syn(Direction.LEFT);
	               potomci[3].setH(which);
	           }
	   }   
	
	
	
	public Uzel vyberNejPotomka(int which) 
	{        
	         int[] minHodnoty = new int[4];
	         int nejlepsichSynu = 0;
	         for(int i = 0, nejlepsi = ( (which == 1) ? 9 : 33) ; i<4; i++)
	           {if  (potomci[i] != null) 
	                {   
	                    if ((potomci[i].getH(which) < nejlepsi) && !potomci[i].used() )  
	                     {nejlepsi = potomci[i].getH(which);
	                      nejlepsichSynu = 1;
	                      minHodnoty[0] = i; //i-ty potomek z matice current.potomci
	                     }
	                    else if (potomci[i].getH(which) == nejlepsi)
	                     {nejlepsichSynu++;
	                      minHodnoty[nejlepsichSynu - 1] = i;
	                     }
	                 }
	             
	           }
	         if (nejlepsichSynu == 0)
	           return null;
	         else
	          {
	            Random mujRandom = new Random();
	            int chosen = minHodnoty[mujRandom.nextInt(nejlepsichSynu)];
	            return potomci[chosen];
	          }
	         
	         	         
   }    
   
   
   private boolean used() //zjistit, jestli se uzel uz neopakoval (navstiveny stav)
	{
             Uzel current = this.getOtec();
	         while(current != null)
	          {if (isEqual(current.ctverce))
	              {
	                  return true;//opakuje se, smazat ho a zkusit nejakeho jineho
	              }
	                  
	           else 
	              current = current.getOtec(); //splahani nahoru az k rootu a porovnavani
	          }   
	           
	        return false;
	}        

}
